package com.mydomain.testquartz.action;

import java.util.Date;

import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Observer;
import org.jboss.seam.async.QuartzDispatcher;
import org.jboss.seam.log.LogProvider;
import org.jboss.seam.log.Logging;
import org.quartz.JobDataMap;
import org.quartz.JobDetail;
import org.quartz.Scheduler;
import org.quartz.SimpleTrigger;

@Name("test")
public class MyTestProcess
{
   LogProvider flog = Logging.getLogProvider(MyTestProcess.class);

   @Observer("org.jboss.seam.postInitialization")
   public void observe()
   {

      try
      {
         flog.info("OBSERVING MyTestProcess ........... ");
         QuartzDispatcher fQuartzDispatcher = QuartzDispatcher.instance();
         Scheduler fScheduler = fQuartzDispatcher.getScheduler();

         JobDetail fJobDetail = new JobDetail("MyJob1", fScheduler.DEFAULT_GROUP, MyJob.class);

         SimpleTrigger fSimpleTrigger = new SimpleTrigger("MyTrigger", fScheduler.DEFAULT_GROUP, new Date(), null, SimpleTrigger.REPEAT_INDEFINITELY, (long) 1000);

         JobDataMap fJobDataMap = fJobDetail.getJobDataMap();

         //fJobDataMap.put("Processor", fMyProcessor);
         fJobDataMap.put("QuartzScheduler", fScheduler);

         fScheduler.scheduleJob(fJobDetail, fSimpleTrigger);

      }

      catch (Exception fException)
      {

         flog.error(fException.getMessage());

      }

   }
}
